<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_MeetingPoint ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_MeetingPoint extends AbstractStructArrayBase
{
    /**
     * The MeetingPoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_MeetingPoint[]
     */
    public $MeetingPoint;
    /**
     * Constructor method for ArrayOfJP_MeetingPoint
     * @uses ArrayOfJP_MeetingPoint::setMeetingPoint()
     * @param \StructType\JP_MeetingPoint[] $meetingPoint
     */
    public function __construct(array $meetingPoint = array())
    {
        $this
            ->setMeetingPoint($meetingPoint);
    }
    /**
     * Get MeetingPoint value
     * @return \StructType\JP_MeetingPoint[]|null
     */
    public function getMeetingPoint()
    {
        return $this->MeetingPoint;
    }
    /**
     * This method is responsible for validating the values passed to the setMeetingPoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMeetingPoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMeetingPointForArrayConstraintsFromSetMeetingPoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_MeetingPointMeetingPointItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_MeetingPointMeetingPointItem instanceof \StructType\JP_MeetingPoint) {
                $invalidValues[] = is_object($arrayOfJP_MeetingPointMeetingPointItem) ? get_class($arrayOfJP_MeetingPointMeetingPointItem) : sprintf('%s(%s)', gettype($arrayOfJP_MeetingPointMeetingPointItem), var_export($arrayOfJP_MeetingPointMeetingPointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MeetingPoint property can only contain items of type \StructType\JP_MeetingPoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MeetingPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MeetingPoint[] $meetingPoint
     * @return \ArrayType\ArrayOfJP_MeetingPoint
     */
    public function setMeetingPoint(array $meetingPoint = array())
    {
        // validation for constraint: array
        if ('' !== ($meetingPointArrayErrorMessage = self::validateMeetingPointForArrayConstraintsFromSetMeetingPoint($meetingPoint))) {
            throw new \InvalidArgumentException($meetingPointArrayErrorMessage, __LINE__);
        }
        $this->MeetingPoint = $meetingPoint;
        return $this;
    }
    /**
     * Add item to MeetingPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_MeetingPoint $item
     * @return \ArrayType\ArrayOfJP_MeetingPoint
     */
    public function addToMeetingPoint(\StructType\JP_MeetingPoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_MeetingPoint) {
            throw new \InvalidArgumentException(sprintf('The MeetingPoint property can only contain items of type \StructType\JP_MeetingPoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MeetingPoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_MeetingPoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_MeetingPoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_MeetingPoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_MeetingPoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_MeetingPoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MeetingPoint
     */
    public function getAttributeName()
    {
        return 'MeetingPoint';
    }
}
